import { ref as S, defineComponent as g, openBlock as p, createElementBlock as u, Fragment as $, renderSlot as _, onMounted as L, nextTick as P, createVNode as T, createSlots as N, withCtx as A, createElementVNode as n, unref as i, getCurrentInstance as O, createBlock as V, normalizeProps as E, mergeProps as F, normalizeClass as f, createTextVNode as D, toDisplayString as q, withDirectives as x, vShow as M, computed as j } from "vue";
import { createHighlighter as Q } from "shiki";
const R = /document\.addEventListener\s*\(\s*['"]DOMContentLoaded['"]\s*,\s*(function\s*\([^)]*\)\s*\{|\([^)]*\)\s*=>\s*\{)([\s\S]*?(\{[\s\S]*?\}[\s\S]*?)*)\}\s*\);?\s*|document\.addEventListener\s*\(\s*['"]DOMContentLoaded['"]\s*,\s*(\w+)\s*\);?\s*/;
function k() {
  const s = S("");
  async function e(o, t) {
    const d = await Q({
      langs: [],
      themes: Object.values(t)
    });
    await d.loadLanguage("templ"), s.value = d.codeToHtml(o, {
      lang: "templ",
      themes: t,
      defaultColor: !1
    });
  }
  return {
    highlightedCode: s,
    highlightCode: e
  };
}
function H(s) {
  return s.replace(
    /"([^"]*\[[^'"]*="[^'"]*"\][^"]*)"/g,
    function(e, o) {
      return `'${o}'`;
    }
  );
}
function B() {
  const s = document.querySelector(
    ".preview-content"
  );
  s && (new MutationObserver((o) => {
    o.forEach((t) => {
      t.type === "childList" && K(t.target);
    });
  }).observe(s, { childList: !0, subtree: !0 }), K(s));
}
function K(s) {
  s.querySelectorAll("script").forEach((o) => {
    o.getAttribute("data-executed") || (o.textContent && W(o.textContent), o.setAttribute("data-executed", "true"));
  });
}
function W(s) {
  const e = R.exec(s);
  if (e) {
    const o = s.replace(e[0], "").trim();
    if (o && y(o), e[2]) {
      const t = e[2].trim();
      y(`(function() { ${t} })();`);
    } else if (e[4]) {
      const t = e[4].trim();
      y(`${t}();`);
    }
  } else
    y(s);
}
function y(s) {
  var o;
  const e = document.createElement("script");
  e.setAttribute("data-executed", "true"), e.textContent = s, (o = document.body.appendChild(e).parentNode) == null || o.removeChild(e);
}
const G = /* @__PURE__ */ g({
  __name: "ConditionalWrapper",
  props: {
    isPreviewFirst: { type: Boolean }
  },
  setup(s) {
    const e = s;
    return (o, t) => (p(), u("div", null, [
      e.isPreviewFirst ? (p(), u($, { key: 0 }, [
        _(o.$slots, "preview"),
        _(o.$slots, "code")
      ], 64)) : (p(), u($, { key: 1 }, [
        _(o.$slots, "code"),
        _(o.$slots, "preview")
      ], 64))
    ]));
  }
}), J = { class: "container" }, U = { class: "preview" }, X = ["innerHTML"], Y = { class: "code-content" }, ee = { class: "language-templ vp-adaptive-theme" }, te = ["innerHTML"], ne = /* @__PURE__ */ g({
  __name: "VTPCard",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(s) {
    const e = s, o = H(e.htmlContent), { highlightedCode: t, highlightCode: d } = k();
    return L(async () => {
      await d(e.codeContent, e.themes), P(() => {
        B();
      });
    }), (b, c) => (p(), u("div", J, [
      T(G, {
        "is-preview-first": e.isPreviewFirst
      }, N({
        preview: A(() => [
          n("div", U, [
            n("div", {
              class: "preview-content",
              innerHTML: i(o)
            }, null, 8, X)
          ])
        ]),
        _: 2
      }, [
        e.isPreviewOnly ? void 0 : {
          name: "code",
          fn: A(() => [
            n("div", Y, [
              n("div", ee, [
                c[0] || (c[0] = n("button", {
                  title: "Copy Code",
                  class: "copy"
                }, null, -1)),
                c[1] || (c[1] = n("span", { class: "lang" }, "templ", -1)),
                n("span", {
                  class: "vp-code",
                  innerHTML: i(t)
                }, null, 8, te)
              ])
            ])
          ]),
          key: "0"
        }
      ]), 1032, ["is-preview-first"])
    ]));
  }
}), z = (s, e) => {
  const o = s.__vccOpts || s;
  for (const [t, d] of e)
    o[t] = d;
  return o;
}, I = /* @__PURE__ */ z(ne, [["__scopeId", "data-v-73284cea"]]), oe = ["width", "height", "fill"], Z = /* @__PURE__ */ g({
  __name: "CodeIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(s) {
    const e = s;
    return (o, t) => (p(), u("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: e.size,
      height: e.size,
      viewBox: "0 0 16 16",
      fill: e.fill,
      "aria-hidden": "true"
    }, t[0] || (t[0] = [
      n("path", {
        "fill-rule": "evenodd",
        d: "M4.78 4.97a.75.75 0 0 1 0 1.06L2.81 8l1.97 1.97a.75.75 0 1 1-1.06 1.06l-2.5-2.5a.75.75 0 0 1 0-1.06l2.5-2.5a.75.75 0 0 1 1.06 0ZM11.22 4.97a.75.75 0 0 0 0 1.06L13.19 8l-1.97 1.97a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 0 0-1.06 0ZM8.856 2.008a.75.75 0 0 1 .636.848l-1.5 10.5a.75.75 0 0 1-1.484-.212l1.5-10.5a.75.75 0 0 1 .848-.636Z",
        "clip-rule": "evenodd"
      }, null, -1)
    ]), 8, oe));
  }
}), se = {
  key: 1,
  class: "container"
}, ie = { class: "preview" }, le = ["innerHTML"], ae = { class: "code-section" }, re = ["aria-controls"], ce = ["id", "aria-hidden"], de = { class: "language-templ vp-adaptive-theme" }, pe = ["innerHTML"], ue = /* @__PURE__ */ g({
  __name: "VTPCodeToggle",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(s) {
    const e = s, o = H(e.htmlContent), t = S(!1), { highlightedCode: d, highlightCode: b } = k(), c = O(), a = c ? c.uid.toString() : Math.random().toString(36).substring(2, 11);
    function h() {
      t.value = !t.value;
    }
    return L(async () => {
      await b(e.codeContent, e.themes), P(() => {
        B();
      });
    }), (w, l) => e.isPreviewOnly ? (p(), V(I, E(F({ key: 0 }, e)), null, 16)) : (p(), u("div", se, [
      n("div", ie, [
        n("div", {
          class: "preview-content",
          innerHTML: i(o)
        }, null, 8, le)
      ]),
      n("div", ae, [
        n("button", {
          class: f(`button-${e.buttonStyle}`),
          "aria-controls": "code-content-" + i(a),
          "aria-label": "view the source code",
          onClick: h
        }, [
          _(w.$slots, "code-icon", {}, () => [
            T(Z, {
              fill: `var(--vp-button-${e.buttonStyle}-text)`
            }, null, 8, ["fill"])
          ], !0),
          D(" " + q(t.value ? "Hide Code" : "Show Code"), 1)
        ], 10, re),
        n("div", {
          id: "code-content-" + i(a),
          class: "code-content",
          "aria-hidden": !t.value
        }, [
          n("div", null, [
            n("div", de, [
              l[0] || (l[0] = n("button", {
                title: "Copy Code",
                class: "copy"
              }, null, -1)),
              l[1] || (l[1] = n("span", { class: "lang" }, "templ", -1)),
              n("span", {
                class: "vp-code",
                innerHTML: i(d)
              }, null, 8, pe)
            ])
          ])
        ], 8, ce)
      ])
    ]));
  }
}), Fe = /* @__PURE__ */ z(ue, [["__scopeId", "data-v-c488ac8b"]]), ve = { class: "wrapper" }, he = {
  class: "tabs",
  role: "tablist"
}, we = ["id", "aria-selected", "aria-controls"], me = ["id", "aria-selected", "aria-controls"], _e = ["id"], ge = ["innerHTML"], be = { class: "code-content" }, Ce = { class: "language-templ vp-adaptive-theme" }, fe = ["innerHTML"], ye = /* @__PURE__ */ g({
  __name: "VTPTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(s) {
    const e = s, o = H(e.htmlContent), t = S("preview"), { highlightedCode: d, highlightCode: b } = k(), c = O(), a = c ? c.uid.toString() : Math.random().toString(36).substring(2, 11), h = (w, l) => {
      (w.key === "Enter" || w.key === " ") && (t.value = l);
    };
    return L(async () => {
      await b(e.codeContent, e.themes), P(() => {
        B();
      });
    }), (w, l) => e.isPreviewOnly ? (p(), V(I, E(F({ key: 0 }, e)), null, 16)) : (p(), u($, { key: 1 }, [
      n("div", ve, [
        n("div", he, [
          n("button", {
            id: "tab-preview-" + i(a),
            role: "tab",
            "aria-selected": t.value === "preview",
            class: f({ active: t.value === "preview" }),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(a),
            "aria-label": "preview the component",
            onClick: l[0] || (l[0] = (v) => t.value = "preview"),
            onKeydown: l[1] || (l[1] = (v) => h(v, "preview"))
          }, " Preview ", 42, we),
          n("button", {
            id: "tab-code-" + i(a),
            role: "tab",
            "aria-selected": t.value === "code",
            class: f({ active: t.value === "code" }),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(a),
            "aria-label": "view the source code",
            onClick: l[2] || (l[2] = (v) => t.value = "code"),
            onKeydown: l[3] || (l[3] = (v) => h(v, "code"))
          }, " Code ", 42, me)
        ])
      ]),
      n("div", {
        id: "tabpanel-" + t.value + "-" + i(a),
        class: "tab-content",
        role: "tabpanel"
      }, [
        x(n("div", {
          class: "preview-content",
          innerHTML: i(o)
        }, null, 8, ge), [
          [M, t.value === "preview"]
        ]),
        x(n("div", be, [
          n("div", Ce, [
            l[4] || (l[4] = n("button", {
              title: "Copy Code",
              class: "copy"
            }, null, -1)),
            l[5] || (l[5] = n("span", { class: "lang" }, "templ", -1)),
            n("span", {
              class: "vp-code",
              innerHTML: i(d)
            }, null, 8, fe)
          ])
        ], 512), [
          [M, t.value === "code"]
        ])
      ], 8, _e)
    ], 64));
  }
}), Ie = /* @__PURE__ */ z(ye, [["__scopeId", "data-v-668010f6"]]), $e = ["width", "height", "fill"], Te = /* @__PURE__ */ g({
  __name: "ViewIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(s) {
    const e = s;
    return (o, t) => (p(), u("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: e.size,
      height: e.size,
      viewBox: "0 0 16 16",
      fill: e.fill,
      "aria-hidden": "true"
    }, t[0] || (t[0] = [
      n("path", { d: "M8 9.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z" }, null, -1),
      n("path", {
        "fill-rule": "evenodd",
        d: "M1.38 8.28a.87.87 0 0 1 0-.566 7.003 7.003 0 0 1 13.238.006.87.87 0 0 1 0 .566A7.003 7.003 0 0 1 1.379 8.28ZM11 8a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z",
        "clip-rule": "evenodd"
      }, null, -1)
    ]), 8, $e));
  }
}), xe = { class: "wrapper" }, Me = {
  class: "tabs",
  role: "tablist"
}, Se = ["id", "aria-selected", "aria-controls"], Le = ["id", "aria-selected", "aria-controls"], Pe = ["id"], ke = ["innerHTML"], He = { class: "code-content" }, Be = { class: "language-templ vp-adaptive-theme" }, ze = ["innerHTML"], Oe = /* @__PURE__ */ g({
  __name: "VTPIconTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(s) {
    const e = s, o = H(e.htmlContent), t = S("preview"), { highlightedCode: d, highlightCode: b } = k(), c = O(), a = c ? c.uid.toString() : Math.random().toString(36).substring(2, 11), h = (m) => j(() => t.value === m ? "var(--vp-button-brand-text)" : "var(--vp-button-alt-text)"), w = h("preview"), l = h("code"), v = (m, r) => {
      (m.key === "Enter" || m.key === " ") && (t.value = r);
    };
    return L(async () => {
      await b(e.codeContent, e.themes), P(() => {
        B();
      });
    }), (m, r) => e.isPreviewOnly ? (p(), V(I, E(F({ key: 0 }, e)), null, 16)) : (p(), u($, { key: 1 }, [
      n("div", xe, [
        n("div", Me, [
          n("button", {
            id: "tab-preview-" + i(a),
            role: "tab",
            "aria-selected": t.value === "preview",
            class: f({ active: t.value === "preview" }),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(a),
            "aria-label": "preview the component",
            onClick: r[0] || (r[0] = (C) => t.value = "preview"),
            onKeydown: r[1] || (r[1] = (C) => v(C, "preview"))
          }, [
            _(m.$slots, "preview-icon", {}, () => [
              T(Te, { fill: i(w) }, null, 8, ["fill"])
            ], !0)
          ], 42, Se),
          n("button", {
            id: "tab-code-" + i(a),
            role: "tab",
            "aria-selected": t.value === "code",
            class: f({ active: t.value === "code" }),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(a),
            "aria-label": "view the source code",
            onClick: r[2] || (r[2] = (C) => t.value = "code"),
            onKeydown: r[3] || (r[3] = (C) => v(C, "code"))
          }, [
            _(m.$slots, "code-icon", {}, () => [
              T(Z, { fill: i(l) }, null, 8, ["fill"])
            ], !0)
          ], 42, Le)
        ])
      ]),
      n("div", {
        id: "tabpanel-" + t.value + "-" + i(a),
        class: "tab-content",
        role: "tabpanel"
      }, [
        x(n("div", {
          class: "preview-content",
          innerHTML: i(o)
        }, null, 8, ke), [
          [M, t.value === "preview"]
        ]),
        x(n("div", He, [
          n("div", Be, [
            r[4] || (r[4] = n("button", {
              title: "Copy Code",
              class: "copy"
            }, null, -1)),
            r[5] || (r[5] = n("span", { class: "lang" }, "templ", -1)),
            n("span", {
              class: "vp-code",
              innerHTML: i(d)
            }, null, 8, ze)
          ])
        ], 512), [
          [M, t.value === "code"]
        ])
      ], 8, Pe)
    ], 64));
  }
}), Ae = /* @__PURE__ */ z(Oe, [["__scopeId", "data-v-98593276"]]);
export {
  I as VTPCard,
  Fe as VTPCodeToggle,
  Ae as VTPIconTabs,
  Ie as VTPTabs
};
